unit ParallelProgramming1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,
  OtlComm,
  OtlTask,
  OtlTaskControl, StdCtrls, Spin;

const
  MSG_NUM_PRIMES = WM_USER;
  MSG_DO_THE_CALC = WM_USER + 1;
  MSG_TIMER = WM_USER + 2;

type
  TForm3 = class(TForm)
    btnBeep: TButton;
    btnBgPrimes: TButton;
    lbLog: TListBox;
    inpHighPrime: TSpinEdit;
    btnStartBgPrimes: TButton;
    btnStopBgPrimes: TButton;
    btnBgCalc: TButton;
    btnTimer: TButton;
    procedure btnBeepClick(Sender: TObject);
    procedure btnBgCalcClick(Sender: TObject);
    procedure btnBgPrimesClick(Sender: TObject);
    procedure btnStartBgPrimesClick(Sender: TObject);
    procedure btnStopBgPrimesClick(Sender: TObject);
    procedure btnTimerClick(Sender: TObject);
  private
    FBgTask: IOmniTaskControl;
    FBgTask2: IOmniTaskControl;
  public
    procedure NumPrimes(var msg: TOmniMessage); message MSG_NUM_PRIMES;
    procedure Timer(var msg: TOmniMessage); message MSG_TIMER;
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

type
  TBgPrimes = class(TOmniWorker)
  published
    procedure DoTheCalc(var msg: TOmniMessage); message MSG_DO_THE_CALC;
    procedure Timer;
  end;

function IsPrime(i: integer): boolean;
var
  j: Integer;
begin
  Result := false;
  for j := 2 to Trunc(Sqrt(i)) do
    if i mod j = 0 then
      Exit;
  Result := true;
end;

function CountPrimesTo(high: integer): integer;
var
  i: Integer;
begin
  Result := 0;
  for i := 2 to high do
    if IsPrime(i) then
      Inc(Result);
end;

procedure BgBeep(const task: IOmniTask);
begin
  Sleep(2000);
  MessageBeep($FFFFFFFF);
end;

procedure TForm3.btnBeepClick(Sender: TObject);
begin
 // CreateTask(BgBeep, 'Background Beep').Schedule;
 TThread.CreateAnonymousThread(
   procedure begin
     Sleep(2000);
     MessageBeep($FFFFFFFF);
   end
 ).Start;
end;

procedure BgPrimes(const task: IOmniTask);
var
  numPrimes: Integer;
begin
  numPrimes := CountPrimesTo(task.Param['NumPrimes']);
  task.Comm.Send(MSG_NUM_PRIMES, numPrimes);
end;

procedure TForm3.btnBgCalcClick(Sender: TObject);
begin
  FBgTask2.Comm.Send(MSG_DO_THE_CALC, inpHighPrime.Value);
end;

procedure TForm3.btnBgPrimesClick(Sender: TObject);
begin
  FBgTask :=
    CreateTask(BgPrimes, 'Background primes')
    .SetParameter('NumPrimes', inpHighPrime.Value)
    .OnMessage(Self)
    .Run;
end;

procedure TForm3.btnStartBgPrimesClick(Sender: TObject);
begin
  FBgTask2 :=
    CreateTask(TBgPrimes.Create(), 'Background primes')
    .OnMessage(Self)
    .Run;
end;

procedure TForm3.btnStopBgPrimesClick(Sender: TObject);
begin
  FBgTask2.Terminate;
  FBgTask2 := nil;
end;

procedure TForm3.btnTimerClick(Sender: TObject);
begin
  FBgTask2.SetTimer(0, 1111, @TBgPrimes.Timer)
end;

procedure TForm3.NumPrimes(var msg: TOmniMessage);
begin
  lbLog.Items.Add(IntToStr(msg.MsgData));
  if assigned(FBgTask) then begin
    FBgTask.Terminate;
    FBgTask := nil;
  end;
end;

procedure TForm3.Timer(var msg: TOmniMessage);
begin
  lbLog.Items.Add('Timer');
end;

{ TBgPrimes }

procedure TBgPrimes.DoTheCalc(var msg: TOmniMessage);
begin
  Task.Comm.Send(MSG_NUM_PRIMES,
    CountPrimesTo(msg.MsgData));
end;

procedure TBgPrimes.Timer;
begin
  Task.Comm.Send(MSG_TIMER);
end;

end.
